unit Glob;

interface
uses classes, comctrls, Graphics, Forms;

var Received:TStringList;
    Users:TStringList;
    MainReceived:TRichEdit;
    PopupPrivate:boolean;
    MainWnd:integer;
    MainForm:TForm;

    clNormal:TColor;
    clJoinedChannel:TColor;
    clUserJoinChannel:TColor;
    clUserPartChannel:TColor;
    clInfo:TColor;
    clError:TColor;
    clTalk:TColor;
    clOwnTalk:TColor;
    clWhisper:TColor;
    clEmote:TColor;

const
  sclNormal:TColor=clBlack;
  sclJoinedChannel:TColor=clRed;
  sclUserJoinChannel:TColor=clGreen;
  sclUserPartChannel:TColor=clGreen;
  sclInfo:TColor=clRed;
  sclError:TColor=clRed;
  sclTalk:TColor=clBlack;
  sclOwnTalk:TColor=clTeal;
  sclWhisper:TColor=clFuchsia;
  sclEmote:TColor=clBlue;


Function WSAErrorToString(errno:integer):String;


implementation
uses winsock;

Function WSAErrorToString(errno:integer):String;
Begin
  case errno of
    WSABASEERR: result:='Unknown error';
    WSAEINTR: result:='The (blocking) call was canceled using WSACancelBlockingCall';
    WSAEBADF: result:='WSAEBADF';
    WSAEACCES: result:='WSAEACCES';
    WSAEFAULT: result:='The addrlen argument is too small (less than the size of a sockets address structure)';
    WSAEINVAL: result:='WSAEINVAL';
    WSAEMFILE: result:='No more file descriptors available';
    WSAEWOULDBLOCK: result:='WSAEWOULDBLOCK';
    WSAEINPROGRESS: result:='A blocking Windows Sockets operation is in progress';
    WSAEALREADY: result:='WSAEALREADY';
    WSAENOTSOCK: result:='WSAENOTSOCK';
    WSAEDESTADDRREQ: result:='WSAEDESTADDRREQ';
    WSAEMSGSIZE: result:='WSAEMSGSIZE';
    WSAEPROTOTYPE: result:='WSAEPROTOTYPE: The specified protocol is the wrong type for this socket';
    WSAENOPROTOOPT: result:='WSAENOPROTOOPT';
    WSAEPROTONOSUPPORT: result:='WSAEPROTONOSUPPORT: The specified protocol is not supported';
    WSAESOCKTNOSUPPORT: result:='WSAESOCKTNOSUPPORT: The specified socket type is not supported in this address family';
    WSAEOPNOTSUPP: result:='WSAEOPNOTSUPP';
    WSAEPFNOSUPPORT: result:='WSAEPFNOSUPPORT';
    WSAEAFNOSUPPORT: result:='WSAEAFNOSUPPORT: The specified address family is not supported';
    WSAEADDRINUSE: result:='WSAEADDRINUSE';
    WSAEADDRNOTAVAIL: result:='WSAEADDRNOTAVAIL';
    WSAENETDOWN: result:='WSAENETDOWN: The Windows Sockets implementation has detected that the network subsystem has failed';
    WSAENETUNREACH: result:='WSAENETUNREACH';
    WSAENETRESET: result:='WSAENETRESET';
    WSAECONNABORTED: result:='WSAECONNABORTED';
    WSAECONNRESET: result:='WSAECONNRESET';
    WSAENOBUFS: result:='WSAENOBUFS: No buffer space is available. The socket cannot be created';
    WSAEISCONN: result:='WSAEISCONN';
    WSAENOTCONN: result:='WSAENOTCONN';
    WSAESHUTDOWN: result:='WSAESHUTDOWN';
    WSAETOOMANYREFS: result:='WSAETOOMANYREFS';
    WSAETIMEDOUT: result:='WSAETIMEDOUT';
    WSAECONNREFUSED: result:='WSAECONNREFUSED';
    WSAELOOP: result:='WSAELOOP';
    WSAENAMETOOLONG: result:='WSAENAMETOOLONG';
    WSAEHOSTDOWN: result:='WSAEHOSTDOWN';
    WSAEHOSTUNREACH: result:='WSAEHOSTUNREACH';
    WSAENOTEMPTY: result:='WSAENOTEMPTY';
    WSAEPROCLIM: result:='WSAEPROCLIM';
    WSAEUSERS: result:='WSAEUSERS';
    WSAEDQUOT: result:='WSAEDQUOT';
    WSAESTALE: result:='WSAESTALE';
    WSAEREMOTE: result:='WSAEREMOTE';
    WSAEDISCON: result:='WSAEDISCON';
    WSASYSNOTREADY: result:='WSASYSNOTREADY';
    WSAVERNOTSUPPORTED: result:='WSAVERNOTSUPPORTED';
    WSANOTINITIALISED: result:='WSA Not initialised';
    WSAHOST_NOT_FOUND: result:='WSA Host not found';
    WSATRY_AGAIN: result:='WSA Try again';
    WSANO_RECOVERY: result:='WSA No recovery';
    WSANO_DATA: result:='No data';
  else
    result:='Unknown error';
  end;
end;

begin
end.
