unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin, ScktComp, Interpreter, ExtCtrls, Ltimer,
  registry,SetColors;

type
  TForm1 = class(TForm)
    ed_received: TRichEdit;
    lb_Users: TListBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ed_Homechannel: TComboBox;
    ed_User: TEdit;
    ed_Password: TEdit;
    but_Connect: TButton;
    ed_Port: TSpinEdit;
    ClientSocket: TClientSocket;
    cb_Popup: TCheckBox;
    Label4: TLabel;
    Label8: TLabel;
    lab_CurrentChannel: TLabel;
    Panel2: TPanel;
    Label5: TLabel;
    ed_Send: TEdit;
    Panel3: TPanel;
    Panel4: TPanel;
    but_Go: TButton;
    Label9: TLabel;
    ed_AntiIdle: TEdit;
    but_GuestLogin: TButton;
    but_AdjustColors: TButton;
    ed_Address: TComboBox;
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure but_ConnectClick(Sender: TObject);
    procedure ed_SendKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cb_PopupClick(Sender: TObject);
    procedure but_GoClick(Sender: TObject);
    procedure lb_UsersDblClick(Sender: TObject);
    procedure but_GuestLoginClick(Sender: TObject);
    procedure but_AdjustColorsClick(Sender: TObject);
  private
    FSocket: TCustomWinSocket;
    FConnected: Boolean;
    FInterpreter:TInterpreter;
    LastLine:String;
    linecache:TStringList;
    Function ReadDef(R:TRegistry; Ident, Def:String):String;
    procedure ReadRegistry;
    procedure WriteRegistry;
  public
    procedure ResetSysColors;
    procedure ReceivedStr(s:String; col:TColor);
    procedure SetZOrder(TopMost: Boolean); override;
    procedure SendStr(S:String);
    procedure WriteLog(S:String);
    procedure UsersChanged(Sender:TObject);
    procedure Pong(Sender:TObject);
  end;

var
  Form1: TForm1;

implementation
uses Glob;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FConnected:=false;
  FSocket:=nil;
  FInterpreter:=TInterpreter.Create;
  FInterpreter.OnUsersChanged:=UsersChanged;
  FInterpreter.Pong:=Pong;
  PopupPrivate:=true;
  MainWnd:=Handle;
  linecache:=TStringList.Create;
end;

procedure TForm1.UsersChanged(Sender:TObject);
var i:integer;
Begin
  lab_CurrentChannel.Caption:=FInterpreter.CurrentChannel;
  lb_Users.Clear;
  for i:=0 to Users.Count-1 do lb_Users.Items.Add(Users.Strings[i]);
End;

procedure TForm1.SendStr(S:String);
var emote:boolean;
Begin
  if s='' then exit;
  if FConnected then
  begin
    FSocket.SendText(S+#13#10);
    emote:=false;
    if (uppercase(copy(s,1,6))='/EMOTE') then emote:=true;
    if ((s[1]<>'/') or (emote)) and (s[1]<>#3) then
    begin
      if emote then
      begin
        delete(s,1,6);
        s:='<'+FInterpreter.OwnNick+S+'>';
        ReceivedStr(s, clEmote);
      end
      else
      begin
        S:='<'+FInterpreter.OwnNick+'> '+S;
        ReceivedStr(s, clOwnTalk);
      end;
    end;
//    WriteLog('> '+S+#13#10);
  end;
End;

procedure TForm1.WriteLog(S:String);
var f:textfile;
Begin
  assignfile(f,'c:\battlenet.txt');
  if FileExists('c:\battlenet.txt') then
    Append(f) else Rewrite(f);
  writeln(f, s);
  closefile(f);
End;

procedure TForm1.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ReceivedStr('** Connected', clInfo);
  FSocket:=Socket;
  FConnected:=true;
  ReceivedStr('** Sending userinfo...', clInfo);
  SendStr(#3#4+ed_User.Text+#13#10+ed_Password.Text);
  ReceivedStr('** Waiting for repsonse', clInfo);
  SendStr('/join '+ed_Homechannel.Text);
end;

procedure TForm1.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  FConnected:=false;
  FSocket:=nil;
  ReceivedStr('**** Disconnected ****', clError);
  but_Connect.Tag:=0;
  but_Connect.Caption:='Connect';
  ClientSocket.Active:=False;
  lb_Users.Clear;
  lab_CurrentChannel.Caption:='';
end;

procedure TForm1.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  FConnected:=false;
  FSocket:=nil;
  ReceivedStr(Format('**** Error %s, disconnected ****', [WSAErrorToString(ErrorCode)]), clError);
  ErrorCode:=0;
  but_Connect.Tag:=0;
  but_Connect.Caption:='Connect';
  ClientSocket.Active:=False;
  lb_Users.Clear;
  lab_CurrentChannel.Caption:='';
end;
procedure TForm1.Pong(Sender:TObject);
Begin
  SendStr(ed_AntiIdle.Text);
End;

procedure TForm1.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
var s,line:string;
    i:integer;
begin
  s:=LastLine+Socket.ReceiveText;
  repeat
    i:=pos(#13, s);
    if i=0 then i:=pos(#10, s);
    if i>0 then
    begin
      line:=copy(s,1,i-1);
      if (i<length(s)) and ((s[i+1]=#13) or (s[i+1]=#10)) then
        i:=i+1;
      if line<>'' then Received.Add(line);
      delete(s,1,i);
    end
    else
      LastLine:=s;
  until i=0;
end;

procedure TForm1.but_ConnectClick(Sender: TObject);
var s:string;
    i:integer;
begin
  if but_Connect.Tag=0 then
  begin
    but_Connect.Tag:=1;
    LastLine:='';
    but_Connect.Caption:='Disconnect';
    s:=ed_Address.Text;
    i:=pos(' ',s);
    if i>0 then delete(s,i,length(s)-i+1);
    ClientSocket.Host:=s;
    ClientSocket.Port:=ed_Port.Value;
    try
      ClientSocket.Active:=true;
    except
      but_Connect.Tag:=0;
      but_Connect.Caption:='Connect';
      ClientSocket.Active:=False;
      lb_Users.Clear;
      lab_CurrentChannel.Caption:='';
      ReceivedStr('** Error connecting to '+s,clError)
    end;
  end
  else
  begin
    but_Connect.Tag:=0;
    but_Connect.Caption:='Connect';
    ClientSocket.Active:=False;
    lb_Users.Clear;
    lab_CurrentChannel.Caption:='';
  end;
end;

procedure TForm1.ed_SendKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_Return then
  begin
    key:=0;
    SendStr(ed_Send.Text);
    linecache.insert(0, ed_Send.Text);
    if linecache.count>20 then
      linecache.delete(linecache.count-1);
    ed_Send.Text:='';
  end else
  if key = vk_Up then
  begin
    key:=0;
    if linecache.count=0 then exit;
    ed_Send.Text:=linecache.Strings[0];
    linecache.delete(0);
    linecache.add(ed_Send.Text);
  end else
  if key = vk_Down then
  begin
    key:=0;
    if linecache.count=0 then exit;
    ed_Send.Text:=linecache.Strings[linecache.Count-1];
    linecache.delete(linecache.Count-1);
    linecache.Insert(0, ed_Send.Text);
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  MainReceived:=ed_received;
  MainForm:=Self;
  ReadRegistry;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WriteRegistry;
  FInterpreter.free;
  linecache.free;
end;

procedure TForm1.cb_PopupClick(Sender: TObject);
begin
  PopupPrivate:=cb_Popup.Checked;
end;




procedure TForm1.but_GoClick(Sender: TObject);
begin
  SendStr('/join '+ed_Homechannel.Text);
end;

procedure TForm1.lb_UsersDblClick(Sender: TObject);
begin
  if lb_Users.ItemIndex=-1 then exit;
  ed_Send.Text:='/m '+lb_Users.Items[lb_Users.ItemIndex]+' ';
  ed_Send.SetFocus;
  ed_Send.SelStart:=length(ed_Send.Text);
end;

Function TForm1.ReadDef(R:TRegistry; Ident, Def:String):String;
Begin
  Result:=R.ReadString(Ident);
  if Result='' then Result:=Def;
End;

procedure TForm1.ReadRegistry;
var R:TRegistry;
Begin
  R:=TRegistry.Create;
  R.RootKey:=HKEY_LOCAL_MACHINE;
  R.OpenKey('SOFTWARE\Rover\BattleChat', true);
  ed_User.Text:=ReadDef(R, 'Username', 'guest');
  ed_Password.Text:='';
  ed_Homechannel.Text:=ReadDef(R, 'HomeChannel', 'Starcraft 1');
  ed_Address.Text:=ReadDef(R, 'Address', 'battle.net');
  ed_Port.Value:=StrToInt(ReadDef(R, 'Port', '6112'));
  ed_AntiIdle.Text:=ReadDef(R, 'AntiIdle', '/emote zzzZZZzzzZZZzzz');
  cb_Popup.checked:=ReadDef(R, 'PopupOnPrivate', '1')='1';

  if R.KeyExists('clNormal') then
  begin
    clNormal:=StrToInt(ReadDef(R, 'clNormal', inttostr(sclNormal)));
    clJoinedChannel:=StrToInt(ReadDef(R, 'clJoinedChannel', inttostr(sclJoinedChannel)));
    clUserJoinChannel:=StrToInt(ReadDef(R, 'clUserJoinChannel', inttostr(sclUserJoinChannel)));
    clUserPartChannel:=StrToInt(ReadDef(R, 'clUserPartChannel', inttostr(sclUserPartChannel)));
    clInfo:=StrToInt(ReadDef(R, 'clInfo', inttostr(sclInfo)));
    clError:=StrToInt(ReadDef(R, 'clError', inttostr(sclError)));
    clTalk:=StrToInt(ReadDef(R, 'clTalk', inttostr(sclTalk)));
    clOwnTalk:=StrToInt(ReadDef(R, 'clOwnTalk', inttostr(sclOwnTalk)));
    clWhisper:=StrToInt(ReadDef(R, 'clWhisper', inttostr(sclWhisper)));
    clEmote:=StrToInt(ReadDef(R, 'clEmote', inttostr(sclEmote)));
  end
  else
    ResetSysColors;

  R.free;
End;
procedure TForm1.WriteRegistry;
var R:TRegistry;
Begin
  R:=TRegistry.Create;
  R.RootKey:=HKEY_LOCAL_MACHINE;
  R.OpenKey('SOFTWARE\Rover\BattleChat', true);
  R.WriteString('Username', ed_User.Text);
  ed_Password.Text:='';
  R.WriteString('HomeChannel', ed_Homechannel.Text);
  R.WriteString('Address', ed_Address.Text);
  R.WriteString('Port', inttostr(ed_Port.Value));
  R.WriteString('AntiIdle', ed_AntiIdle.Text);
  if cb_Popup.checked then
    R.WriteString('PopupOnPrivate', '1') else
    R.WriteString('PopupOnPrivate', '0');

  R.WriteInteger('clNormal', clNormal);
  R.WriteInteger('clJoinedChannel', clJoinedChannel);
  R.WriteInteger('clUserJoinChannel', clUserJoinChannel);
  R.WriteInteger('clUserPartChannel', clUserPartChannel);
  R.WriteInteger('clInfo', clInfo);
  R.WriteInteger('clError', clError);
  R.WriteInteger('clTalk', clTalk);
  R.WriteInteger('clOwnTalk', clOwnTalk);
  R.WriteInteger('clWhisper', clWhisper);
  R.WriteInteger('clEmote', clEmote);

  R.free;
End;

procedure TForm1.but_GuestLoginClick(Sender: TObject);
begin
  ed_User.Text:='guest';
  ed_Password.Text:='anynomous';
end;

procedure TForm1.SetZOrder(TopMost: Boolean);
begin
  inherited;
end;

procedure TForm1.ReceivedStr(s:String; col:TColor);
var oldcount:integer;
begin
  with ed_Received do
  begin
    oldcount:=Lines.Count;
    SelStart:=length(Text);
    SelAttributes.Color:=col;
    SelText:=s+#13#10;

    if Lines.count>100 then
    begin
      Lines.Delete(0);
    end;
    oldcount:=Lines.Count-oldcount;
    repeat
      PostMessage(MainReceived.Handle,EM_SCROLL,SB_LINEDOWN,0);
      dec(oldcount);
    until oldcount<=0;
  end;
end;

procedure TForm1.ResetSysColors;
Begin
  clNormal:=sclNormal;
  clJoinedChannel:=sclJoinedChannel;
  clUserJoinChannel:=sclUserJoinChannel;
  clUserPartChannel:=sclUserPartChannel;
  clInfo:=sclInfo;
  clError:=sclError;
  clTalk:=sclTalk;
  clOwnTalk:=sclOwnTalk;
  clWhisper:=sclWhisper;
  clEmote:=sclEmote;
end;

procedure TForm1.but_AdjustColorsClick(Sender: TObject);
begin
  frmSetColors:=TfrmSetColors.Create(Self);
  with frmSetColors do
  begin
    pa_clNormal.Font.Color:=clNormal;
    pa_clJoinedChannel.Font.Color:=clJoinedChannel;
    pa_clUserJoinChannel.Font.Color:=clUserJoinChannel;
    pa_clUserPartChannel.Font.Color:=clUserPartChannel;
    pa_clInfo.Font.Color:=clInfo;
    pa_clError.Font.Color:=clError;
    pa_clTalk.Font.Color:=clTalk;
    pa_clOwnTalk.Font.Color:=clOwnTalk;
    pa_clWhisper.Font.Color:=clWhisper;
    pa_clEmote.Font.Color:=clEmote;
    if ShowModal=idOk then
    begin
      clNormal:=pa_clNormal.Font.Color;
      clJoinedChannel:=pa_clJoinedChannel.Font.Color;
      clUserJoinChannel:=pa_clUserJoinChannel.Font.Color;
      clUserPartChannel:=pa_clUserPartChannel.Font.Color;
      clInfo:=pa_clInfo.Font.Color;
      clError:=pa_clError.Font.Color;
      clTalk:=pa_clTalk.Font.Color;
      clOwnTalk:=pa_clOwnTalk.Font.Color;
      clWhisper:=pa_clWhisper.Font.Color;
      clEmote:=pa_clEmote.Font.Color;
    end;
  end;
  frmSetColors.Free;
end;

end.
